Package org.apache.lucene.codecs.lucene95

# Class OffHeapByteVectorValues

java.lang.Object
org.apache.lucene.index.KnnVectorValues
org.apache.lucene.index.ByteVectorValues
org.apache.lucene.codecs.lucene95.OffHeapByteVectorValues

All Implemented Interfaces:
  `HasIndexSlice`

Direct Known Subclasses:
  `OffHeapByteVectorValues.DenseOffHeapVectorValues`

public abstract class OffHeapByteVectorValues extends ByteVectorValues implements HasIndexSlice
Read the vector values from the index input. This supports both iterated and random access.

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`OffHeapByteVectorValues.DenseOffHeapVectorValues`
Dense vector values that are stored off-heap.

## Nested classes/interfaces inherited from class org.apache.lucene.index.KnnVectorValues

`KnnVectorValues.DocIndexIterator`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final byte[]`
`binaryValue`
`protected final ByteBuffer`
`byteBuffer`
`protected final int`
`byteSize`
`protected final int`
`dimension`
`protected final FlatVectorsScorer`
`flatVectorsScorer`
`protected int`
`lastOrd`
`protected final VectorSimilarityFunction`
`similarityFunction`
`protected final int`
`size`
`protected final IndexInput`
`slice`

## Method Summary

Modifier and Type
Method
Description
`int`
`dimension()`
Return the dimension of the vectors
`IndexInput`
`getSlice()`
Returns an IndexInput from which to read this instance's values.
`static OffHeapByteVectorValues`
`load(VectorSimilarityFunction vectorSimilarityFunction, FlatVectorsScorer flatVectorsScorer, OrdToDocDISIReaderConfiguration configuration, VectorEncoding vectorEncoding, int dimension, long vectorDataOffset, long vectorDataLength, IndexInput vectorData)`
`int`
`size()`
Return the number of vectors for this field.
`byte[]`
`vectorValue(int targetOrd)`
Return the vector value for the given vector ordinal which must be in [0, size() - 1], otherwise IndexOutOfBoundsException is thrown.

### Methods inherited from class org.apache.lucene.index.ByteVectorValues

`checkField, copy, fromBytes, getEncoding, scorer`

### Methods inherited from class org.apache.lucene.index.KnnVectorValues

`createDenseIterator, createSparseIterator, fromDISI, getAcceptOrds, getVectorByteLength, iterator, ordToDoc`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### dimension

protected final int dimension

### size

protected final int size

### slice

protected final IndexInput slice

### lastOrd

protected int lastOrd

### binaryValue

protected final byte[] binaryValue

### byteBuffer

protected final ByteBuffer byteBuffer

### byteSize

protected final int byteSize

### similarityFunction

protected final VectorSimilarityFunction similarityFunction

### flatVectorsScorer

protected final FlatVectorsScorer flatVectorsScorer

## Method Details

### dimension

public int dimension()
Description copied from class: `KnnVectorValues`
Return the dimension of the vectors

Specified by:
  `dimension` in class `KnnVectorValues`

### size

public int size()
Description copied from class: `KnnVectorValues`
Return the number of vectors for this field.

Specified by:
  `size` in class `KnnVectorValues`
Returns:
  the number of vectors returned by this iterator

### vectorValue

public byte[] vectorValue(int targetOrd) throws IOException
Description copied from class: `ByteVectorValues`
Return the vector value for the given vector ordinal which must be in [0, size() - 1], otherwise IndexOutOfBoundsException is thrown. The returned array may be shared across calls.

Specified by:
  `vectorValue` in class `ByteVectorValues`
Returns:
  the vector value
Throws:
  `IOException`

### getSlice

public IndexInput getSlice()
Description copied from interface: `HasIndexSlice`
Returns an IndexInput from which to read this instance's values.

Specified by:
  `getSlice` in interface `HasIndexSlice`

### load

public static OffHeapByteVectorValues load(VectorSimilarityFunction vectorSimilarityFunction, FlatVectorsScorer flatVectorsScorer, OrdToDocDISIReaderConfiguration configuration, VectorEncoding vectorEncoding, int dimension, long vectorDataOffset, long vectorDataLength, IndexInput vectorData) throws IOException

Throws:
  `IOException`